"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const web3_js_1 = require("@solana/web3.js");
const client_1 = require("../client");
const config_1 = require("../config");
const fs = __importStar(require("fs"));
const os = __importStar(require("os"));
const utils_1 = require("../utils/utils");
const mango_client_1 = require("@blockworks-foundation/mango-client");
const groupName = process.env.GROUP || 'devnet.2';
const cluster = (process.env.CLUSTER || groupName.split('.')[0]);
const config = config_1.Config.ids();
const connection = new web3_js_1.Connection(config.cluster_urls[cluster], 'confirmed');
const groupIds = config.getGroup(cluster, groupName);
const mangoProgramId = groupIds.mangoProgramId;
const mangoGroupKey = groupIds.publicKey;
const client = new client_1.MangoClient(connection, mangoProgramId);
const payer = web3_js_1.Keypair.fromSecretKey(Uint8Array.from(JSON.parse(process.env.KEYPAIR ||
    fs.readFileSync(os.homedir() + '/.config/solana/devnet.json', 'utf-8'))));
const payer1 = web3_js_1.Keypair.fromSecretKey(Uint8Array.from(JSON.parse(process.env.KEYPAIR ||
    fs.readFileSync(os.homedir() + '/.config/solana/azzers.json', 'utf-8'))));
const makerPk = new web3_js_1.PublicKey('6rnq9ajZpJCkDe3xP7WAs9KFgLAhQWA2gyz1zVv2cnTn');
const takerPk = new web3_js_1.PublicKey('HGaFMw6fJmTzL3wq2H9tXXj2sx3BMg7kYtJmgedvKrJy');
const referrerPkTier1 = new web3_js_1.PublicKey('DxUrnFn3GF9cK3YTv33oA4VVDP2yRa5BtS6MrHY5yFKY');
const referrerPkTier2 = new web3_js_1.PublicKey('Dh9x94vQzNdBAtqCufNFuNkLnYZ57iNMpZWHwxNisYHH');
function check() {
    return __awaiter(this, void 0, void 0, function* () {
        const group = yield client.getMangoGroup(mangoGroupKey);
        console.log('cache', group.mangoCache.toBase58());
        console.log('referrer mngo required', (0, utils_1.nativeToUi)(group.refMngoRequired.toNumber(), 6), 'ref share tier 1', group.refShareCentibpsTier1, 'ref surcharge tier 1', group.refSurchargeCentibpsTier1, 'ref share tier 2', group.refShareCentibpsTier2, 'ref surcharge tier 2', group.refSurchargeCentibpsTier2, 'ref tier 2 factor', group.refMngoTier2Factor);
        if (groupName == 'devnet.2') {
            const perpMarketConfig = groupIds.perpMarkets.find((p) => p.baseSymbol == 'AVAX');
            const perpMarketInfo = group.perpMarkets[perpMarketConfig.marketIndex];
            const perpMarket = yield group.loadPerpMarket(connection, perpMarketConfig.marketIndex, perpMarketConfig.baseDecimals, perpMarketConfig.quoteDecimals);
            console.log('maker fee', perpMarketInfo.makerFee.toNumber(), 'taker fee', perpMarketInfo.takerFee.toNumber());
            const makerAccount = yield client.getMangoAccount(makerPk, group.dexProgramId);
            const takerAccount = yield client.getMangoAccount(takerPk, group.dexProgramId);
            const referrerAccountTier1 = yield client.getMangoAccount(referrerPkTier1, group.dexProgramId);
            const referrerAccountTier2 = yield client.getMangoAccount(referrerPkTier2, group.dexProgramId);
            const cache = yield group.loadCache(connection);
            const mngoIndex = group.getRootBankIndex(groupIds.tokens.find((t) => t.symbol == 'MNGO').rootKey);
            const referrerQuoteTier1 = referrerAccountTier1.perpAccounts[perpMarketConfig.marketIndex].quotePosition.toNumber();
            console.log('referrer tier 1 mngo', referrerAccountTier1
                .getUiDeposit(cache.rootBankCache[mngoIndex], group, mngoIndex)
                .toNumber(), 'referrer tier 1 avax quote', referrerQuoteTier1);
            const referrerQuoteTier2 = referrerAccountTier2.perpAccounts[perpMarketConfig.marketIndex].quotePosition.toNumber();
            console.log('referrer tier 2 mngo', referrerAccountTier2
                .getUiDeposit(cache.rootBankCache[mngoIndex], group, mngoIndex)
                .toNumber(), 'referrer tier 2 avax quote', referrerQuoteTier2);
            // No referrer
            // Place maker order
            let ts = Date.now();
            console.log('maker order', yield client.placePerpOrder2(group, makerAccount, perpMarket, payer, 'sell', 15.5, 1, { clientOrderId: ts, expiryTimestamp: 60, expiryType: 'relative' }));
            // Place taker order that will match
            console.log('taker order', yield client.placePerpOrder2(group, takerAccount, perpMarket, payer, 'buy', 16, 1));
            yield (0, mango_client_1.sleep)(5000);
            // Load fills
            const fills = (yield perpMarket.loadFills(connection)).filter((f) => f.maker.equals(makerPk) && f.makerClientOrderId.toNumber() == ts);
            // With referrer tier 1
            // Place maker order
            ts = Date.now();
            console.log('maker order (ref tier 1)', yield client.placePerpOrder2(group, makerAccount, perpMarket, payer, 'sell', 15.5, 1, { referrerMangoAccountPk: referrerPkTier1, clientOrderId: ts }));
            // Place taker order that will match
            console.log('taker order (ref tier 1)', yield client.placePerpOrder2(group, takerAccount, perpMarket, payer, 'buy', 16, 1, { referrerMangoAccountPk: referrerPkTier1 }));
            yield (0, mango_client_1.sleep)(5000);
            // Load fills
            const referrerFillsTier1 = (yield perpMarket.loadFills(connection)).filter((f) => f.maker.equals(makerPk) && f.makerClientOrderId.toNumber() == ts);
            // With referrer tier 2
            // Place maker order
            ts = Date.now();
            console.log('maker order (ref tier 2)', yield client.placePerpOrder2(group, makerAccount, perpMarket, payer, 'sell', 15.5, 1, { referrerMangoAccountPk: referrerPkTier2, clientOrderId: ts }));
            // Place taker order that will match
            console.log('taker order (ref tier 2)', yield client.placePerpOrder2(group, takerAccount, perpMarket, payer, 'buy', 16, 1, { referrerMangoAccountPk: referrerPkTier2 }));
            yield (0, mango_client_1.sleep)(5000);
            // Load fills
            const referrerFillsTier2 = (yield perpMarket.loadFills(connection)).filter((f) => f.maker.equals(makerPk) && f.makerClientOrderId.toNumber() == ts);
            yield referrerAccountTier1.reload(connection, groupIds.mangoProgramId);
            yield referrerAccountTier2.reload(connection, groupIds.mangoProgramId);
            const referrerQuoteTier1Post = referrerAccountTier1.perpAccounts[perpMarketConfig.marketIndex].quotePosition.toNumber();
            const referrerQuoteTier2Post = referrerAccountTier2.perpAccounts[perpMarketConfig.marketIndex].quotePosition.toNumber();
            // By tier 1
            // Place maker order
            ts = Date.now();
            console.log('maker order (tier 1)', yield client.placePerpOrder2(group, makerAccount, perpMarket, payer, 'sell', 15.5, 1, { clientOrderId: ts }));
            // Place taker order that will match
            console.log('taker order (tier 1)', yield client.placePerpOrder2(group, referrerAccountTier1, perpMarket, payer1, 'buy', 16, 1));
            yield (0, mango_client_1.sleep)(5000);
            // Load fills
            const fillsTier1 = (yield perpMarket.loadFills(connection)).filter((f) => f.maker.equals(makerPk) && f.makerClientOrderId.toNumber() == ts);
            // By tier 2
            // Place maker order
            ts = Date.now();
            console.log('maker order (tier 2)', yield client.placePerpOrder2(group, makerAccount, perpMarket, payer, 'sell', 15.5, 1, { clientOrderId: ts }));
            // Place taker order that will match
            console.log('taker order (tier 2)', yield client.placePerpOrder2(group, referrerAccountTier2, perpMarket, payer1, 'buy', 16, 1));
            yield (0, mango_client_1.sleep)(5000);
            // Load fills
            const fillsTier2 = (yield perpMarket.loadFills(connection)).filter((f) => f.maker.equals(makerPk) && f.makerClientOrderId.toNumber() == ts);
            fills.forEach((f) => {
                console.log('fill', 'price', f.price, 'quantity', f.quantity, 'maker fee', f.makerFee.toNumber(), 'taker fee', f.takerFee.toNumber());
            });
            referrerFillsTier1.forEach((f) => {
                console.log('fill (ref tier 1)', 'price', f.price, 'quantity', f.quantity, 'maker fee', f.makerFee.toNumber(), 'taker fee', f.takerFee.toNumber());
            });
            referrerFillsTier2.forEach((f) => {
                console.log('fill (ref tier 2)', 'price', f.price, 'quantity', f.quantity, 'maker fee', f.makerFee.toNumber(), 'taker fee', f.takerFee.toNumber());
            });
            fillsTier1.forEach((f) => {
                console.log('fill (tier 1)', 'price', f.price, 'quantity', f.quantity, 'maker fee', f.makerFee.toNumber(), 'taker fee', f.takerFee.toNumber());
            });
            fillsTier2.forEach((f) => {
                console.log('fill (tier 2)', 'price', f.price, 'quantity', f.quantity, 'maker fee', f.makerFee.toNumber(), 'taker fee', f.takerFee.toNumber());
            });
            console.log('referrer quote delta tier 1', referrerQuoteTier1Post - referrerQuoteTier1);
            console.log('referrer quote delta tier 2', referrerQuoteTier2Post - referrerQuoteTier2);
        }
    });
}
check();
//# sourceMappingURL=checkFees.js.map